Index: drivers/filesystems/btrfs/write.c
===================================================================
--- drivers/filesystems/btrfs/write.c	(révision 74430)
+++ drivers/filesystems/btrfs/write.c	(copie de travail)
@@ -786,755 +892,1155 @@
     return STATUS_SUCCESS;
 }
 
-static NTSTATUS STDCALL read_stripe_completion(PDEVICE_OBJECT DeviceObject, PIRP Irp, PVOID ptr) {
-    read_stripe* stripe = ptr;
-    read_stripe_master* master = stripe->master;
-    ULONG stripes_left = InterlockedDecrement(&master->stripes_left);
+static NTSTATUS STDCALL async_read_completion(PDEVICE_OBJECT DeviceObject, PIRP Irp, PVOID conptr) {
+    read_context_stripe* stripe = conptr;
+    LONG left = InterlockedDecrement(&stripe->context->left);
     
+    UNUSED(DeviceObject);
+    
     stripe->iosb = Irp->IoStatus;
     
-    if (stripes_left == 0)
-        KeSetEvent(&master->event, 0, FALSE);
+    if (left == 0)
+        KeSetEvent(&stripe->context->Event, 0, FALSE);
     
     return STATUS_MORE_PROCESSING_REQUIRED;
 }
 
-static NTSTATUS make_read_irp(PIRP old_irp, read_stripe* stripe, UINT64 offset, void* data, UINT32 length) {
+static NTSTATUS async_read_phys(read_context* context, read_context_stripe* stripe, PDEVICE_OBJECT DeviceObject, UINT64 StartingOffset, ULONG Length, PUCHAR Buffer) {
+    LARGE_INTEGER Offset;
+    PIRP Irp;
     PIO_STACK_LOCATION IrpSp;
-    PIRP Irp;
+    NTSTATUS Status;
+
+    Offset.QuadPart = StartingOffset;
+
+    Irp = IoAllocateIrp(DeviceObject->StackSize, FALSE);
     
-    if (!old_irp) {
-        Irp = IoAllocateIrp(stripe->devobj->StackSize, FALSE);
-        
-        if (!Irp) {
-            ERR("IoAllocateIrp failed\n");
-            return STATUS_INSUFFICIENT_RESOURCES;
-        }
-    } else {
-        Irp = IoMakeAssociatedIrp(old_irp, stripe->devobj->StackSize);
-        
-        if (!Irp) {
-            ERR("IoMakeAssociatedIrp failed\n");
-            return STATUS_INSUFFICIENT_RESOURCES;
-        }
+    if (!Irp) {
+        ERR("IoAllocateIrp failed\n");
+        Status = STATUS_INSUFFICIENT_RESOURCES;
+        goto fail;
     }
     
     IrpSp = IoGetNextIrpStackLocation(Irp);
     IrpSp->MajorFunction = IRP_MJ_READ;
     
-    if (stripe->devobj->Flags & DO_BUFFERED_IO) {
-        FIXME("FIXME - buffered IO\n");
-        IoFreeIrp(Irp);
-        return STATUS_INTERNAL_ERROR;
-    } else if (stripe->devobj->Flags & DO_DIRECT_IO) {
-        Irp->MdlAddress = IoAllocateMdl(data, length, FALSE, FALSE, NULL);
+    if (DeviceObject->Flags & DO_BUFFERED_IO) {
+        Irp->AssociatedIrp.SystemBuffer = ExAllocatePoolWithTag(NonPagedPool, Length, ALLOC_TAG);
+        if (!Irp->AssociatedIrp.SystemBuffer) {
+            ERR("out of memory\n");
+            Status = STATUS_INSUFFICIENT_RESOURCES;
+            goto fail;
+        }
+
+        Irp->Flags |= IRP_BUFFERED_IO | IRP_DEALLOCATE_BUFFER | IRP_INPUT_OPERATION;
+
+        Irp->UserBuffer = Buffer;
+    } else if (DeviceObject->Flags & DO_DIRECT_IO) {
+        Irp->MdlAddress = IoAllocateMdl(Buffer, Length, FALSE, FALSE, NULL);
         if (!Irp->MdlAddress) {
             ERR("IoAllocateMdl failed\n");
-            IoFreeIrp(Irp);
-            return STATUS_INSUFFICIENT_RESOURCES;
+            Status = STATUS_INSUFFICIENT_RESOURCES;
+            goto fail;
         }
         
         MmProbeAndLockPages(Irp->MdlAddress, KernelMode, IoWriteAccess);
-    } else {
-        Irp->UserBuffer = data;
-    }
+    } else
+        Irp->UserBuffer = Buffer;
 
-    IrpSp->Parameters.Read.Length = length;
-    IrpSp->Parameters.Read.ByteOffset.QuadPart = offset;
+    IrpSp->Parameters.Read.Length = Length;
+    IrpSp->Parameters.Read.ByteOffset = Offset;
     
+    stripe->context = context;
+    stripe->Irp = Irp;
     Irp->UserIosb = &stripe->iosb;
     
-    IoSetCompletionRoutine(Irp, read_stripe_completion, stripe, TRUE, TRUE, TRUE);
+    IoSetCompletionRoutine(Irp, async_read_completion, stripe, TRUE, TRUE, TRUE);
+
+    Status = IoCallDriver(DeviceObject, Irp);
     
-    stripe->Irp = Irp;
+    if (Status != STATUS_PENDING && !NT_SUCCESS(Status)) {
+        ERR("read returned %08x\n", Status);
+        
+        if (Irp->MdlAddress) {
+            MmUnlockPages(Irp->MdlAddress);
+            IoFreeMdl(Irp->MdlAddress);
+        }
+        
+        goto fail;
+    }
     
     return STATUS_SUCCESS;
+    
+fail:
+    IoFreeIrp(Irp);
+    
+    return Status;
 }
 
-static NTSTATUS prepare_raid5_write(PIRP Irp, chunk* c, UINT64 address, void* data, UINT32 length, write_stripe* stripes) {
-    UINT64 startoff, endoff;
-    UINT16 startoffstripe, endoffstripe, stripenum, parity, logstripe;
-    UINT64 start = 0xffffffffffffffff, end = 0;
-    UINT64 pos, stripepos;
-    UINT32 firststripesize, laststripesize;
+typedef struct {
+    PMDL mdl;
+    PFN_NUMBER* pfns;
+} log_stripe;
+
+static NTSTATUS prepare_raid5_write(device_extension* Vcb, chunk* c, UINT64 address, void* data, UINT32 length, write_stripe* stripes, PIRP Irp,
+                                    UINT32 irp_offset, write_data_context* wtc) {
+    UINT64 startoff, endoff, parity_start, parity_end;
+    UINT16 startoffstripe, endoffstripe, parity;
+    UINT64 pos, parity_pos, *stripeoff = NULL;
     UINT32 i;
-    UINT8* data2 = (UINT8*)data;
-    UINT32 num_reads;
-    BOOL same_stripe = FALSE, multiple_stripes;
+    BOOL file_write = Irp && Irp->MdlAddress && (Irp->MdlAddress->ByteOffset == 0);
+    PMDL master_mdl, fragment_mdl = NULL;
+    NTSTATUS Status;
+    PFN_NUMBER *pfns, *parity_pfns, *fragment_pfns;
+    ULONG fragment_len = 0, num_fragments = 0, frag_num = 0;
+    log_stripe* log_stripes = NULL;
+    UINT8 *fragments = NULL, *fragments2;
+    CHUNK_ITEM_STRIPE* cis = (CHUNK_ITEM_STRIPE*)&c->chunk_item[1];
+    read_context context;
     
+    context.stripes = NULL;
+    
     get_raid0_offset(address - c->offset, c->chunk_item->stripe_length, c->chunk_item->num_stripes - 1, &startoff, &startoffstripe);
     get_raid0_offset(address + length - c->offset - 1, c->chunk_item->stripe_length, c->chunk_item->num_stripes - 1, &endoff, &endoffstripe);
     
-    for (i = 0; i < c->chunk_item->num_stripes - 1; i++) {
-        UINT64 ststart, stend;
+    pos = 0;
+    while (pos < length) {
+        parity = (((address - c->offset + pos) / ((c->chunk_item->num_stripes - 1) * c->chunk_item->stripe_length)) + c->chunk_item->num_stripes - 1) % c->chunk_item->num_stripes;
         
-        if (startoffstripe > i) {
-            ststart = startoff - (startoff % c->chunk_item->stripe_length) + c->chunk_item->stripe_length;
-        } else if (startoffstripe == i) {
-            ststart = startoff;
+        if (pos == 0) {
+            UINT16 stripe = (parity + startoffstripe + 1) % c->chunk_item->num_stripes;
+            ULONG skip, writelen;
+            
+            i = startoffstripe;
+            while (stripe != parity) {
+                if (i == startoffstripe) {
+                    writelen = min(length, c->chunk_item->stripe_length - (startoff % c->chunk_item->stripe_length));
+                    
+                    stripes[stripe].start = startoff;
+                    stripes[stripe].end = startoff + writelen;
+                    
+                    pos += writelen;
+                    
+                    if (pos == length)
+                        break;
+                } else {
+                    writelen = min(length - pos, c->chunk_item->stripe_length);
+                    
+                    stripes[stripe].start = startoff - (startoff % c->chunk_item->stripe_length);
+                    stripes[stripe].end = stripes[stripe].start + writelen;
+                    
+                    pos += writelen;
+                    
+                    if (pos == length)
+                        break;
+                }
+                
+                i++;
+                stripe = (stripe + 1) % c->chunk_item->num_stripes;
+            }
+            
+            if (pos == length)
+                break;
+            
+            for (i = 0; i < startoffstripe; i++) {
+                stripe = (parity + i + 1) % c->chunk_item->num_stripes;
+                
+                stripes[stripe].start = stripes[stripe].end = startoff - (startoff % c->chunk_item->stripe_length) + c->chunk_item->stripe_length;
+            }
+            
+            stripes[parity].start = stripes[parity].end = startoff - (startoff % c->chunk_item->stripe_length) + c->chunk_item->stripe_length;
+            
+            if (length - pos > c->chunk_item->num_stripes * (c->chunk_item->num_stripes - 1) * c->chunk_item->stripe_length) {
+                skip = ((length - pos) / (c->chunk_item->num_stripes * (c->chunk_item->num_stripes - 1) * c->chunk_item->stripe_length)) - 1;
+                
+                for (i = 0; i < c->chunk_item->num_stripes; i++) {
+                    stripes[i].end += skip * c->chunk_item->num_stripes * c->chunk_item->stripe_length;
+                }
+                
+                pos += skip * (c->chunk_item->num_stripes - 1) * c->chunk_item->num_stripes * c->chunk_item->stripe_length;
+            }
+        } else if (length - pos >= c->chunk_item->stripe_length * (c->chunk_item->num_stripes - 1)) {
+            for (i = 0; i < c->chunk_item->num_stripes; i++) {
+                stripes[i].end += c->chunk_item->stripe_length;
+            }
+            
+            pos += c->chunk_item->stripe_length * (c->chunk_item->num_stripes - 1);
         } else {
-            ststart = startoff - (startoff % c->chunk_item->stripe_length);
-        }
-
-        if (endoffstripe > i) {
-            stend = endoff - (endoff % c->chunk_item->stripe_length) + c->chunk_item->stripe_length;
-        } else if (endoffstripe == i) {
-            stend = endoff + 1;
-        } else {
-            stend = endoff - (endoff % c->chunk_item->stripe_length);
-        }
-
-        if (ststart != stend) {
-            stripes[i].start = ststart;
-            stripes[i].end = stend;
+            UINT16 stripe = (parity + 1) % c->chunk_item->num_stripes;
             
-            if (ststart < start) {
-                start = ststart;
-                firststripesize = c->chunk_item->stripe_length - (ststart % c->chunk_item->stripe_length);
+            i = 0;
+            while (stripe != parity) {
+                if (endoffstripe == i) {
+                    stripes[stripe].end = endoff + 1;
+                    break;
+                } else if (endoffstripe > i)
+                    stripes[stripe].end = endoff - (endoff % c->chunk_item->stripe_length) + c->chunk_item->stripe_length;
+                
+                i++;
+                stripe = (stripe + 1) % c->chunk_item->num_stripes;
             }
-
-            if (stend > end) {
-                end = stend;
-                laststripesize = stend % c->chunk_item->stripe_length;
-                if (laststripesize == 0)
-                    laststripesize = c->chunk_item->stripe_length;
-            }
+            
+            break;
         }
     }
     
-    if (start == end) {
-        ERR("error: start == end (%llx)\n", start);
-        return STATUS_INTERNAL_ERROR;
-    }
+    parity_start = 0xffffffffffffffff;
+    parity_end = 0;
     
-    if (startoffstripe == endoffstripe && start / c->chunk_item->stripe_length == end / c->chunk_item->stripe_length) {
-        firststripesize = end - start;
-        laststripesize = firststripesize;
-    }
-
     for (i = 0; i < c->chunk_item->num_stripes; i++) {
-        stripes[i].data = ExAllocatePoolWithTag(NonPagedPool, end - start, ALLOC_TAG);
-        if (!stripes[i].data) {
-            ERR("out of memory\n");
-            return STATUS_INSUFFICIENT_RESOURCES;
+        if (stripes[i].start != 0 || stripes[i].end != 0) {
+            parity_start = min(stripes[i].start, parity_start);
+            parity_end = max(stripes[i].end, parity_end);
         }
-        
-        if (i < c->chunk_item->num_stripes - 1) {
-            if (stripes[i].start == 0 && stripes[i].end == 0)
-                stripes[i].start = stripes[i].end = start;
-        }
     }
     
-    num_reads = 0;
-    multiple_stripes = (end - 1) / c->chunk_item->stripe_length != start / c->chunk_item->stripe_length;
+    if (parity_end == parity_start) {
+        Status = STATUS_SUCCESS;
+        goto exit;
+    }
     
-    for (i = 0; i < c->chunk_item->num_stripes - 1; i++) {
-        if (stripes[i].start == stripes[i].end) {
-            num_reads++;
-            
-            if (multiple_stripes)
-                num_reads++;
+    parity = (((address - c->offset) / ((c->chunk_item->num_stripes - 1) * c->chunk_item->stripe_length)) + c->chunk_item->num_stripes - 1) % c->chunk_item->num_stripes;
+    stripes[parity].start = parity_start;
+    
+    parity = (((address - c->offset + length - 1) / ((c->chunk_item->num_stripes - 1) * c->chunk_item->stripe_length)) + c->chunk_item->num_stripes - 1) % c->chunk_item->num_stripes;
+    stripes[parity].end = parity_end;
+    
+    for (i = 0; i < c->chunk_item->num_stripes; i++) {
+        if (stripes[i].start == 0 && stripes[i].end == 0) {
+            fragment_len += parity_end - parity_start;
+            num_fragments++;
         } else {
-            if (stripes[i].start > start)
-                num_reads++;
+            if (stripes[i].start > parity_start) {
+                fragment_len += stripes[i].start - parity_start;
+                num_fragments++;
+            }
             
-            if (stripes[i].end < end)
-                num_reads++;
+            if (stripes[i].end < parity_end) {
+                fragment_len += parity_end - stripes[i].end;
+                num_fragments++;
+            }
         }
     }
     
-    if (num_reads > 0) {
-        UINT32 j;
-        read_stripe_master* master;
-        read_stripe* read_stripes;
-        CHUNK_ITEM_STRIPE* cis = (CHUNK_ITEM_STRIPE*)&c->chunk_item[1];
-        NTSTATUS Status;
+    if (fragment_len > 0) {
+        fragments = ExAllocatePoolWithTag(NonPagedPool, fragment_len, ALLOC_TAG);
+        if (!fragments) {
+            ERR("out of memory\n");
+            Status = STATUS_INSUFFICIENT_RESOURCES;
+            goto exit;
+        }
+
+        fragment_mdl = IoAllocateMdl(fragments, fragment_len, FALSE, FALSE, NULL);
+        if (!fragment_mdl) {
+            ERR("out of memory\n");
+            Status = STATUS_INSUFFICIENT_RESOURCES;
+            goto exit;
+        }
         
-        master = ExAllocatePoolWithTag(NonPagedPool, sizeof(read_stripe_master), ALLOC_TAG);
-        if (!master) {
+        MmBuildMdlForNonPagedPool(fragment_mdl);
+        
+        fragment_pfns = (PFN_NUMBER*)(fragment_mdl + 1);
+        
+        context.stripes = ExAllocatePoolWithTag(NonPagedPool, sizeof(read_context_stripe) * num_fragments, ALLOC_TAG);
+        if (!context.stripes) {
             ERR("out of memory\n");
-            return STATUS_INSUFFICIENT_RESOURCES;
+            Status = STATUS_INSUFFICIENT_RESOURCES;
+            goto exit;
         }
         
-        read_stripes = ExAllocatePoolWithTag(NonPagedPool, sizeof(read_stripe) * num_reads, ALLOC_TAG);
-        if (!read_stripes) {
+        RtlZeroMemory(context.stripes, sizeof(read_context_stripe) * num_fragments);
+        
+        KeInitializeEvent(&context.Event, NotificationEvent, FALSE);
+        context.total = context.left = num_fragments;
+    }
+    
+    log_stripes = ExAllocatePoolWithTag(NonPagedPool, sizeof(log_stripe) * (c->chunk_item->num_stripes - 1), ALLOC_TAG);
+    if (!log_stripes) {
+        ERR("out of memory\n");
+        Status = STATUS_INSUFFICIENT_RESOURCES;
+        goto exit;
+    }
+    
+    RtlZeroMemory(log_stripes, sizeof(log_stripe) * (c->chunk_item->num_stripes - 1));
+    
+    for (i = 0; i < c->chunk_item->num_stripes - 1; i++) {
+        log_stripes[i].mdl = IoAllocateMdl(NULL, parity_end - parity_start, FALSE, FALSE, NULL);
+        if (!log_stripes[i].mdl) {
             ERR("out of memory\n");
-            ExFreePool(master);
-            return STATUS_INSUFFICIENT_RESOURCES;
+            Status = STATUS_INSUFFICIENT_RESOURCES;
+            goto exit;
         }
         
-        parity = (((address - c->offset) / ((c->chunk_item->num_stripes - 1) * c->chunk_item->stripe_length)) + c->chunk_item->num_stripes - 1) % c->chunk_item->num_stripes;
-        stripenum = (parity + 1) % c->chunk_item->num_stripes;
+        log_stripes[i].mdl->MdlFlags |= MDL_PARTIAL;
+        log_stripes[i].pfns = (PFN_NUMBER*)(log_stripes[i].mdl + 1);
+    }
+    
+    parity = (((address - c->offset) / ((c->chunk_item->num_stripes - 1) * c->chunk_item->stripe_length)) + c->chunk_item->num_stripes - 1) % c->chunk_item->num_stripes;
+    
+    if (fragment_len > 0) {
+        UINT16 stripe = (parity + 1) % c->chunk_item->num_stripes;
         
-        j = 0;
+        fragments2 = fragments;
+        
         for (i = 0; i < c->chunk_item->num_stripes - 1; i++) {
-            if (stripes[i].start > start || stripes[i].start == stripes[i].end) {
-                ULONG readlen;
+            if ((stripes[stripe].start == 0 && stripes[stripe].end == 0) || stripes[stripe].start > parity_start) {
+                ULONG len;
                 
-                read_stripes[j].Irp = NULL;
-                read_stripes[j].devobj = c->devices[stripenum]->devobj;
-                read_stripes[j].master = master;
-                
-                if (stripes[i].start != stripes[i].end)
-                    readlen = stripes[i].start - start;
+                if (stripes[stripe].start == 0 && stripes[stripe].end == 0)
+                    len = parity_end - parity_start;
                 else
-                    readlen = firststripesize;
+                    len = stripes[stripe].start - parity_start;
                 
-                Status = make_read_irp(Irp, &read_stripes[j], start + cis[stripenum].offset, stripes[stripenum].data, readlen);
-                
+                context.stripes[frag_num].dev = c->devices[stripe];
+                Status = async_read_phys(&context, &context.stripes[frag_num], c->devices[stripe]->devobj, cis[stripe].offset + parity_start, len, fragments2);
                 if (!NT_SUCCESS(Status)) {
-                    ERR("make_read_irp returned %08x\n", Status);
-                    j++;
-                    goto readend;
+                    ERR("async_read_phys returned %08x\n", Status);
+                    goto exit;
                 }
                 
-                stripes[stripenum].skip_start = readlen;
+                frag_num++;
                 
-                j++;
-                if (j == num_reads) break;
+                RtlCopyMemory(log_stripes[i].pfns, fragment_pfns, len * sizeof(PFN_NUMBER) >> PAGE_SHIFT);
+                log_stripes[i].pfns += len >> PAGE_SHIFT;
+                
+                fragments2 += len;
+                fragment_pfns += len >> PAGE_SHIFT;
             }
             
-            stripenum = (stripenum + 1) % c->chunk_item->num_stripes;
+            stripe = (stripe + 1) % c->chunk_item->num_stripes;
         }
+    }
+    
+    parity = (((address - c->offset + length - 1) / ((c->chunk_item->num_stripes - 1) * c->chunk_item->stripe_length)) + c->chunk_item->num_stripes - 1) % c->chunk_item->num_stripes;
+    
+    if (fragment_len > 0) {
+        UINT16 stripe = (parity + 1) % c->chunk_item->num_stripes;
         
-        if (j < num_reads) {
-            parity = (((address + length - 1 - c->offset) / ((c->chunk_item->num_stripes - 1) * c->chunk_item->stripe_length)) + c->chunk_item->num_stripes - 1) % c->chunk_item->num_stripes;
-            stripenum = (parity + 1) % c->chunk_item->num_stripes;
-            
-            for (i = 0; i < c->chunk_item->num_stripes - 1; i++) {
-                if ((stripes[i].start != stripes[i].end && stripes[i].end < end) || (stripes[i].start == stripes[i].end && multiple_stripes)) {
-                    read_stripes[j].Irp = NULL;
-                    read_stripes[j].devobj = c->devices[stripenum]->devobj;
-                    read_stripes[j].master = master;
+        for (i = 0; i < c->chunk_item->num_stripes - 1; i++) {
+            if ((stripes[stripe].start != 0 || stripes[stripe].end != 0) && stripes[stripe].end < parity_end) {
+                ULONG len = parity_end - stripes[stripe].end;
+                PFN_NUMBER* pl;
                 
-                    if (stripes[i].start == stripes[i].end) {
-                        Status = make_read_irp(Irp, &read_stripes[j], start + firststripesize + cis[stripenum].offset, &stripes[stripenum].data[firststripesize], laststripesize);
-                        stripes[stripenum].skip_end = laststripesize;
-                    } else {
-                        Status = make_read_irp(Irp, &read_stripes[j], stripes[i].end + cis[stripenum].offset, &stripes[stripenum].data[stripes[i].end - start], end - stripes[i].end);
-                        stripes[stripenum].skip_end = end - stripes[i].end;
-                    }
-                    
-                    if (!NT_SUCCESS(Status)) {
-                        ERR("make_read_irp returned %08x\n", Status);
-                        j++;
-                        goto readend;
-                    }
-                    
-                    j++;
-                    if (j == num_reads) break;
+                context.stripes[frag_num].dev = c->devices[stripe];
+                Status = async_read_phys(&context, &context.stripes[frag_num], c->devices[stripe]->devobj, cis[stripe].offset + stripes[stripe].end, len, fragments2);
+                if (!NT_SUCCESS(Status)) {
+                    ERR("async_read_phys returned %08x\n", Status);
+                    goto exit;
                 }
                 
-                stripenum = (stripenum + 1) % c->chunk_item->num_stripes;
+                frag_num++;
+                
+                pl = (PFN_NUMBER*)(log_stripes[i].mdl + 1);
+                
+                RtlCopyMemory(&pl[(parity_end - parity_start - len) >> PAGE_SHIFT], fragment_pfns, len * sizeof(PFN_NUMBER) >> PAGE_SHIFT);
+                
+                fragments2 += len;
+                fragment_pfns += len >> PAGE_SHIFT;
             }
+            
+            stripe = (stripe + 1) % c->chunk_item->num_stripes;
         }
+    }
+    
+    wtc->parity1 = ExAllocatePoolWithTag(NonPagedPool, parity_end - parity_start, ALLOC_TAG);
+    if (!wtc->parity1) {
+        ERR("out of memory\n");
+        Status = STATUS_INSUFFICIENT_RESOURCES;
+        goto exit;
+    }
+    
+    wtc->parity1_mdl = IoAllocateMdl(wtc->parity1, parity_end - parity_start, FALSE, FALSE, NULL);
+    if (!wtc->parity1_mdl) {
+        ERR("out of memory\n");
+        Status = STATUS_INSUFFICIENT_RESOURCES;
+        goto exit;
+    }
+    
+    MmBuildMdlForNonPagedPool(wtc->parity1_mdl);
+    
+    if (file_write)
+        master_mdl = Irp->MdlAddress;
+    else if (((ULONG_PTR)data % PAGE_SIZE) != 0) {
+        wtc->scratch = ExAllocatePoolWithTag(NonPagedPool, length, ALLOC_TAG);
+        if (!wtc->scratch) {
+            ERR("out of memory\n");
+            Status = STATUS_INSUFFICIENT_RESOURCES;
+            goto exit;
+        }
         
-        master->stripes_left = j;
-        KeInitializeEvent(&master->event, NotificationEvent, FALSE);
+        RtlCopyMemory(wtc->scratch, data, length);
         
-        for (i = 0; i < j; i++) {
-            Status = IoCallDriver(read_stripes[i].devobj, read_stripes[i].Irp);
-            if (!NT_SUCCESS(Status)) {
-                ERR("IoCallDriver returned %08x\n", Status);
-                goto readend;
-            }
+        master_mdl = IoAllocateMdl(wtc->scratch, length, FALSE, FALSE, NULL);
+        if (!master_mdl) {
+            ERR("out of memory\n");
+            Status = STATUS_INSUFFICIENT_RESOURCES;
+            goto exit;
         }
         
-        KeWaitForSingleObject(&master->event, Executive, KernelMode, FALSE, NULL);
+        MmBuildMdlForNonPagedPool(master_mdl);
         
-        for (i = 0; i < j; i++) {
-            if (!NT_SUCCESS(read_stripes[i].iosb.Status)) {
-                Status = read_stripes[i].iosb.Status;
-                goto readend;
-            }
+        wtc->mdl = master_mdl;
+    } else {
+        master_mdl = IoAllocateMdl(data, length, FALSE, FALSE, NULL);
+        if (!master_mdl) {
+            ERR("out of memory\n");
+            Status = STATUS_INSUFFICIENT_RESOURCES;
+            goto exit;
         }
         
-        Status = STATUS_SUCCESS;
-
-readend:
-        for (i = 0; i < j; i++) {
-            if (read_stripes[i].Irp) {
-                if (read_stripes[i].devobj->Flags & DO_DIRECT_IO) {
-                    MmUnlockPages(read_stripes[i].Irp->MdlAddress);
-                    IoFreeMdl(read_stripes[i].Irp->MdlAddress);
-                }
-                
-                IoFreeIrp(read_stripes[i].Irp); // FIXME - what if IoCallDriver fails and other Irps are still running?
+        MmProbeAndLockPages(master_mdl, KernelMode, IoReadAccess);
+        
+        wtc->mdl = master_mdl;
+    }
+    
+    pfns = (PFN_NUMBER*)(master_mdl + 1);
+    parity_pfns = (PFN_NUMBER*)(wtc->parity1_mdl + 1);
+    
+    for (i = 0; i < c->chunk_item->num_stripes; i++) {
+        if (stripes[i].start != stripes[i].end) {
+            stripes[i].mdl = IoAllocateMdl((UINT8*)MmGetMdlVirtualAddress(master_mdl) + irp_offset, stripes[i].end - stripes[i].start, FALSE, FALSE, NULL);
+            if (!stripes[i].mdl) {
+                ERR("IoAllocateMdl failed\n");
+                return STATUS_INSUFFICIENT_RESOURCES;
             }
         }
-        
-        ExFreePool(read_stripes);
-        ExFreePool(master);
-        
-        if (!NT_SUCCESS(Status))
-            return Status;
     }
     
+    stripeoff = ExAllocatePoolWithTag(PagedPool, sizeof(UINT64) * c->chunk_item->num_stripes, ALLOC_TAG);
+    if (!stripeoff) {
+        ERR("out of memory\n");
+        Status = STATUS_INSUFFICIENT_RESOURCES;
+        goto exit;
+    }
+    
+    RtlZeroMemory(stripeoff, sizeof(UINT64) * c->chunk_item->num_stripes);
+    
     pos = 0;
+    parity_pos = 0;
     
-    parity = (((address - c->offset) / ((c->chunk_item->num_stripes - 1) * c->chunk_item->stripe_length)) + c->chunk_item->num_stripes - 1) % c->chunk_item->num_stripes;
-    stripepos = 0;
-    
-    if ((address - c->offset) % (c->chunk_item->stripe_length * (c->chunk_item->num_stripes - 1)) > 0) {
-        UINT16 firstdata;
-        BOOL first = TRUE;
+    while (pos < length) {
+        PFN_NUMBER* stripe_pfns;
         
-        stripenum = (parity + 1) % c->chunk_item->num_stripes;
+        parity = (((address - c->offset + pos) / ((c->chunk_item->num_stripes - 1) * c->chunk_item->stripe_length)) + c->chunk_item->num_stripes - 1) % c->chunk_item->num_stripes;
         
-        for (logstripe = 0; logstripe < c->chunk_item->num_stripes - 1; logstripe++) {
-            ULONG copylen;
+        if (pos == 0) {
+            UINT16 stripe = (parity + startoffstripe + 1) % c->chunk_item->num_stripes;
+            UINT32 writelen = min(length - pos, min(stripes[stripe].end - stripes[stripe].start,
+                                                    c->chunk_item->stripe_length - (stripes[stripe].start % c->chunk_item->stripe_length)));
+            UINT32 maxwritelen = writelen;
             
-            if (pos >= length)
-                break;
+            stripe_pfns = (PFN_NUMBER*)(stripes[stripe].mdl + 1);
             
-            if (stripes[logstripe].start < start + firststripesize && stripes[logstripe].start != stripes[logstripe].end) {
-                copylen = min(start + firststripesize - stripes[logstripe].start, length - pos);
+            RtlCopyMemory(stripe_pfns, pfns, writelen * sizeof(PFN_NUMBER) >> PAGE_SHIFT);
+            
+            RtlCopyMemory(log_stripes[startoffstripe].pfns, pfns, writelen * sizeof(PFN_NUMBER) >> PAGE_SHIFT);
+            log_stripes[startoffstripe].pfns += writelen >> PAGE_SHIFT;
+            
+            stripeoff[stripe] = writelen;
+            pos += writelen;
+            
+            stripe = (stripe + 1) % c->chunk_item->num_stripes;
+            i = startoffstripe + 1;
+            
+            while (stripe != parity) {
+                stripe_pfns = (PFN_NUMBER*)(stripes[stripe].mdl + 1);
+                writelen = min(length - pos, min(stripes[stripe].end - stripes[stripe].start, c->chunk_item->stripe_length));
                 
-                if (!first && copylen < c->chunk_item->stripe_length) {
-                    same_stripe = TRUE;
+                if (writelen == 0)
                     break;
-                }
-
-                RtlCopyMemory(&stripes[stripenum].data[firststripesize - copylen], &data2[pos], copylen);
                 
-                pos += copylen;
-                first = FALSE;
+                if (writelen > maxwritelen)
+                    maxwritelen = writelen;
+                
+                RtlCopyMemory(stripe_pfns, &pfns[pos >> PAGE_SHIFT], writelen * sizeof(PFN_NUMBER) >> PAGE_SHIFT);
+                
+                RtlCopyMemory(log_stripes[i].pfns, &pfns[pos >> PAGE_SHIFT], writelen * sizeof(PFN_NUMBER) >> PAGE_SHIFT);
+                log_stripes[i].pfns += writelen >> PAGE_SHIFT;
+                
+                stripeoff[stripe] = writelen;
+                pos += writelen;
+                
+                stripe = (stripe + 1) % c->chunk_item->num_stripes;
+                i++;
             }
             
-            stripenum = (stripenum + 1) % c->chunk_item->num_stripes;
+            stripe_pfns = (PFN_NUMBER*)(stripes[parity].mdl + 1);
+            
+            RtlCopyMemory(stripe_pfns, parity_pfns, maxwritelen * sizeof(PFN_NUMBER) >> PAGE_SHIFT);
+            stripeoff[parity] = maxwritelen;
+            parity_pos = maxwritelen;
+        } else if (length - pos >= c->chunk_item->stripe_length * (c->chunk_item->num_stripes - 1)) {
+            UINT16 stripe = (parity + 1) % c->chunk_item->num_stripes;
+            
+            i = 0;
+            while (stripe != parity) {
+                stripe_pfns = (PFN_NUMBER*)(stripes[stripe].mdl + 1);
+                
+                RtlCopyMemory(&stripe_pfns[stripeoff[stripe] >> PAGE_SHIFT], &pfns[pos >> PAGE_SHIFT], c->chunk_item->stripe_length * sizeof(PFN_NUMBER) >> PAGE_SHIFT);
+                
+                RtlCopyMemory(log_stripes[i].pfns, &pfns[pos >> PAGE_SHIFT], c->chunk_item->stripe_length * sizeof(PFN_NUMBER) >> PAGE_SHIFT);
+                log_stripes[i].pfns += c->chunk_item->stripe_length >> PAGE_SHIFT;
+                
+                stripeoff[stripe] += c->chunk_item->stripe_length;
+                pos += c->chunk_item->stripe_length;
+                
+                stripe = (stripe + 1) % c->chunk_item->num_stripes;
+                i++;
+            }
+            
+            stripe_pfns = (PFN_NUMBER*)(stripes[parity].mdl + 1);
+            
+            RtlCopyMemory(&stripe_pfns[stripeoff[parity] >> PAGE_SHIFT], &parity_pfns[parity_pos >> PAGE_SHIFT], c->chunk_item->stripe_length * sizeof(PFN_NUMBER) >> PAGE_SHIFT);
+            stripeoff[parity] += c->chunk_item->stripe_length;
+            parity_pos += c->chunk_item->stripe_length;
+        } else {
+            UINT16 stripe = (parity + 1) % c->chunk_item->num_stripes;
+            UINT32 writelen, maxwritelen = 0;
+            
+            i = 0;
+            while (pos < length) {
+                stripe_pfns = (PFN_NUMBER*)(stripes[stripe].mdl + 1);
+                writelen = min(length - pos, min(stripes[stripe].end - stripes[stripe].start, c->chunk_item->stripe_length));
+                
+                if (writelen == 0)
+                    break;
+                
+                if (writelen > maxwritelen)
+                    maxwritelen = writelen;
+                
+                RtlCopyMemory(&stripe_pfns[stripeoff[stripe] >> PAGE_SHIFT], &pfns[pos >> PAGE_SHIFT], writelen * sizeof(PFN_NUMBER) >> PAGE_SHIFT);
+                
+                RtlCopyMemory(log_stripes[i].pfns, &pfns[pos >> PAGE_SHIFT], writelen * sizeof(PFN_NUMBER) >> PAGE_SHIFT);
+                log_stripes[i].pfns += writelen >> PAGE_SHIFT;
+                
+                stripeoff[stripe] += writelen;
+                pos += writelen;
+                
+                stripe = (stripe + 1) % c->chunk_item->num_stripes;
+                i++;
+            }
+            
+            stripe_pfns = (PFN_NUMBER*)(stripes[parity].mdl + 1);
+            
+            RtlCopyMemory(&stripe_pfns[stripeoff[parity] >> PAGE_SHIFT], &parity_pfns[parity_pos >> PAGE_SHIFT], maxwritelen * sizeof(PFN_NUMBER) >> PAGE_SHIFT);
         }
+    }
+    
+    if (fragment_len > 0) {
+        KeWaitForSingleObject(&context.Event, Executive, KernelMode, FALSE, NULL);
         
-        firstdata = parity == 0 ? 1 : 0;
-        
-        RtlCopyMemory(stripes[parity].data, stripes[firstdata].data, firststripesize);
-        
-        for (i = firstdata + 1; i < c->chunk_item->num_stripes; i++) {
-            if (i != parity)
-                do_xor(&stripes[parity].data[0], &stripes[i].data[0], firststripesize);
+        for (i = 0; i < context.total; i++) {
+            if (!NT_SUCCESS(context.stripes[i].iosb.Status)) {
+                Status = context.stripes[i].iosb.Status;
+                ERR("read returned %08x\n", Status);
+                log_device_error(Vcb, context.stripes[i].dev, BTRFS_DEV_STAT_READ_ERRORS);
+                goto exit;
+            }
         }
+    }
+
+    for (i = 0; i < c->chunk_item->num_stripes - 1; i++) {
+        UINT8* ss = MmGetSystemAddressForMdlSafe(log_stripes[i].mdl, NormalPagePriority);
         
-        if (!same_stripe) {
-            stripepos = firststripesize;
-            parity = (parity + 1) % c->chunk_item->num_stripes;
-        }
+        if (i == 0)
+            RtlCopyMemory(wtc->parity1, ss, parity_end - parity_start);
+        else
+            do_xor(wtc->parity1, ss, parity_end - parity_start);
     }
     
-    while (length >= pos + c->chunk_item->stripe_length * (c->chunk_item->num_stripes - 1)) {
-        UINT16 firstdata;
-        
-        stripenum = (parity + 1) % c->chunk_item->num_stripes;
-        
+    Status = STATUS_SUCCESS;
+    
+exit:
+    if (log_stripes) {
         for (i = 0; i < c->chunk_item->num_stripes - 1; i++) {
-            RtlCopyMemory(&stripes[stripenum].data[stripepos], &data2[pos], c->chunk_item->stripe_length);
-            
-            pos += c->chunk_item->stripe_length;
-            stripenum = (stripenum +1) % c->chunk_item->num_stripes;
+            if (log_stripes[i].mdl)
+                IoFreeMdl(log_stripes[i].mdl);
         }
         
-        firstdata = parity == 0 ? 1 : 0;
-        
-        RtlCopyMemory(&stripes[parity].data[stripepos], &stripes[firstdata].data[stripepos], c->chunk_item->stripe_length);
-        
-        for (i = firstdata + 1; i < c->chunk_item->num_stripes; i++) {
-            if (i != parity)
-                do_xor(&stripes[parity].data[stripepos], &stripes[i].data[stripepos], c->chunk_item->stripe_length);
-        }
-        
-        parity = (parity + 1) % c->chunk_item->num_stripes;
-        stripepos += c->chunk_item->stripe_length;
+        ExFreePool(log_stripes);
     }
     
-    if (pos < length) {
-        UINT16 firstdata;
-        
-        if (!same_stripe) {
-            stripenum = (parity + 1) % c->chunk_item->num_stripes;
-            i = 0;
-        } else
-            i = logstripe;
-        
-        while (pos < length) {
-            ULONG copylen;
+    if (context.stripes) {
+        if (context.total > 0) {
+            KeWaitForSingleObject(&context.Event, Executive, KernelMode, FALSE, NULL);
             
-            copylen = min(stripes[i].end - start - stripepos, length - pos);
-
-            RtlCopyMemory(&stripes[stripenum].data[stripepos], &data2[pos], copylen);
-            
-            pos += copylen;
-            stripenum = (stripenum + 1) % c->chunk_item->num_stripes;
-            i++;
+            for (i = 0; i < context.total; i++) {
+                if (context.stripes[i].Irp && context.stripes[i].Irp->MdlAddress) {
+                    MmUnlockPages(context.stripes[i].Irp->MdlAddress);
+                    IoFreeMdl(context.stripes[i].Irp->MdlAddress);
+                }
+            }
         }
         
-        firstdata = parity == 0 ? 1 : 0;
-        
-        RtlCopyMemory(&stripes[parity].data[stripepos], &stripes[firstdata].data[stripepos], laststripesize);
-        
-        for (i = firstdata + 1; i < c->chunk_item->num_stripes; i++) {
-            if (i != parity)
-                do_xor(&stripes[parity].data[stripepos], &stripes[i].data[stripepos], laststripesize);
-        }
+        ExFreePool(context.stripes);
     }
     
-    for (i = 0; i < c->chunk_item->num_stripes; i++) {
-        stripes[i].start = start;
-        stripes[i].end = end;
-    }
+    if (fragment_mdl)
+        IoFreeMdl(fragment_mdl);
     
-    return STATUS_SUCCESS;
+    if (fragments)
+        ExFreePool(fragments);
+
+    if (stripeoff)
+        ExFreePool(stripeoff);
+    
+    return Status;
 }
 
-static NTSTATUS prepare_raid6_write(PIRP Irp, chunk* c, UINT64 address, void* data, UINT32 length, write_stripe* stripes) {
-    UINT64 startoff, endoff;
-    UINT16 startoffstripe, endoffstripe, stripenum, parity1, parity2, logstripe;
-    UINT64 start = 0xffffffffffffffff, end = 0;
-    UINT64 pos, stripepos;
-    UINT32 firststripesize, laststripesize;
+static NTSTATUS prepare_raid6_write(device_extension* Vcb, chunk* c, UINT64 address, void* data, UINT32 length, write_stripe* stripes, PIRP Irp,
+                                    UINT32 irp_offset, write_data_context* wtc) {
+    UINT64 startoff, endoff, parity_start, parity_end;
+    UINT16 startoffstripe, endoffstripe, parity1;
+    UINT64 pos, parity_pos, *stripeoff = NULL;
     UINT32 i;
-    UINT8* data2 = (UINT8*)data;
-    UINT32 num_reads;
-    BOOL same_stripe = FALSE, multiple_stripes;
+    BOOL file_write = Irp && Irp->MdlAddress && (Irp->MdlAddress->ByteOffset == 0);
+    PMDL master_mdl, fragment_mdl = NULL;
+    NTSTATUS Status;
+    PFN_NUMBER *pfns, *parity1_pfns, *parity2_pfns, *fragment_pfns;
+    ULONG fragment_len = 0, num_fragments = 0, frag_num = 0;
+    log_stripe* log_stripes = NULL;
+    UINT8 *fragments = NULL, *fragments2;
+    CHUNK_ITEM_STRIPE* cis = (CHUNK_ITEM_STRIPE*)&c->chunk_item[1];
+    read_context context;
     
+    context.stripes = NULL;
+    
     get_raid0_offset(address - c->offset, c->chunk_item->stripe_length, c->chunk_item->num_stripes - 2, &startoff, &startoffstripe);
     get_raid0_offset(address + length - c->offset - 1, c->chunk_item->stripe_length, c->chunk_item->num_stripes - 2, &endoff, &endoffstripe);
     
-    for (i = 0; i < c->chunk_item->num_stripes - 2; i++) {
-        UINT64 ststart, stend;
+    pos = 0;
+    while (pos < length) {
+        parity1 = (((address - c->offset + pos) / ((c->chunk_item->num_stripes - 2) * c->chunk_item->stripe_length)) + c->chunk_item->num_stripes - 2) % c->chunk_item->num_stripes;
         
-        if (startoffstripe > i) {
-            ststart = startoff - (startoff % c->chunk_item->stripe_length) + c->chunk_item->stripe_length;
-        } else if (startoffstripe == i) {
-            ststart = startoff;
+        if (pos == 0) {
+            UINT16 stripe = (parity1 + startoffstripe + 2) % c->chunk_item->num_stripes;
+            UINT16 parity2 = (parity1 + 1) % c->chunk_item->num_stripes;
+            ULONG skip, writelen;
+            
+            i = startoffstripe;
+            while (stripe != parity1) {
+                if (i == startoffstripe) {
+                    writelen = min(length, c->chunk_item->stripe_length - (startoff % c->chunk_item->stripe_length));
+                    
+                    stripes[stripe].start = startoff;
+                    stripes[stripe].end = startoff + writelen;
+                    
+                    pos += writelen;
+                    
+                    if (pos == length)
+                        break;
+                } else {
+                    writelen = min(length - pos, c->chunk_item->stripe_length);
+                    
+                    stripes[stripe].start = startoff - (startoff % c->chunk_item->stripe_length);
+                    stripes[stripe].end = stripes[stripe].start + writelen;
+                    
+                    pos += writelen;
+                    
+                    if (pos == length)
+                        break;
+                }
+                
+                i++;
+                stripe = (stripe + 1) % c->chunk_item->num_stripes;
+            }
+            
+            if (pos == length)
+                break;
+            
+            for (i = 0; i < startoffstripe; i++) {
+                stripe = (parity1 + i + 2) % c->chunk_item->num_stripes;
+                
+                stripes[stripe].start = stripes[stripe].end = startoff - (startoff % c->chunk_item->stripe_length) + c->chunk_item->stripe_length;
+            }
+            
+            stripes[parity1].start = stripes[parity1].end = stripes[parity2].start = stripes[parity2].end = 
+                startoff - (startoff % c->chunk_item->stripe_length) + c->chunk_item->stripe_length;
+            
+            if (length - pos > c->chunk_item->num_stripes * (c->chunk_item->num_stripes - 2) * c->chunk_item->stripe_length) {
+                skip = ((length - pos) / (c->chunk_item->num_stripes * (c->chunk_item->num_stripes - 2) * c->chunk_item->stripe_length)) - 1;
+                
+                for (i = 0; i < c->chunk_item->num_stripes; i++) {
+                    stripes[i].end += skip * c->chunk_item->num_stripes * c->chunk_item->stripe_length;
+                }
+                
+                pos += skip * (c->chunk_item->num_stripes - 2) * c->chunk_item->num_stripes * c->chunk_item->stripe_length;
+            }
+        } else if (length - pos >= c->chunk_item->stripe_length * (c->chunk_item->num_stripes - 2)) {
+            for (i = 0; i < c->chunk_item->num_stripes; i++) {
+                stripes[i].end += c->chunk_item->stripe_length;
+            }
+            
+            pos += c->chunk_item->stripe_length * (c->chunk_item->num_stripes - 2);
         } else {
-            ststart = startoff - (startoff % c->chunk_item->stripe_length);
-        }
-
-        if (endoffstripe > i) {
-            stend = endoff - (endoff % c->chunk_item->stripe_length) + c->chunk_item->stripe_length;
-        } else if (endoffstripe == i) {
-            stend = endoff + 1;
-        } else {
-            stend = endoff - (endoff % c->chunk_item->stripe_length);
-        }
-
-        if (ststart != stend) {
-            stripes[i].start = ststart;
-            stripes[i].end = stend;
+            UINT16 stripe = (parity1 + 2) % c->chunk_item->num_stripes;
             
-            if (ststart < start) {
-                start = ststart;
-                firststripesize = c->chunk_item->stripe_length - (ststart % c->chunk_item->stripe_length);
+            i = 0;
+            while (stripe != parity1) {
+                if (endoffstripe == i) {
+                    stripes[stripe].end = endoff + 1;
+                    break;
+                } else if (endoffstripe > i)
+                    stripes[stripe].end = endoff - (endoff % c->chunk_item->stripe_length) + c->chunk_item->stripe_length;
+                
+                i++;
+                stripe = (stripe + 1) % c->chunk_item->num_stripes;
             }
-
-            if (stend > end) {
-                end = stend;
-                laststripesize = stend % c->chunk_item->stripe_length;
-                if (laststripesize == 0)
-                    laststripesize = c->chunk_item->stripe_length;
-            }
+            
+            break;
         }
     }
     
-    if (start == end) {
-        ERR("error: start == end (%llx)\n", start);
-        return STATUS_INTERNAL_ERROR;
-    }
+    parity_start = 0xffffffffffffffff;
+    parity_end = 0;
     
-    if (startoffstripe == endoffstripe && start / c->chunk_item->stripe_length == end / c->chunk_item->stripe_length) {
-        firststripesize = end - start;
-        laststripesize = firststripesize;
-    }
-
     for (i = 0; i < c->chunk_item->num_stripes; i++) {
-        stripes[i].data = ExAllocatePoolWithTag(NonPagedPool, end - start, ALLOC_TAG);
-        if (!stripes[i].data) {
-            ERR("out of memory\n");
-            return STATUS_INSUFFICIENT_RESOURCES;
+        if (stripes[i].start != 0 || stripes[i].end != 0) {
+            parity_start = min(stripes[i].start, parity_start);
+            parity_end = max(stripes[i].end, parity_end);
         }
-        
-        if (i < c->chunk_item->num_stripes - 2) {
-            if (stripes[i].start == 0 && stripes[i].end == 0)
-                stripes[i].start = stripes[i].end = start;
-        }
     }
     
-    num_reads = 0;
-    multiple_stripes = (end - 1) / c->chunk_item->stripe_length != start / c->chunk_item->stripe_length;
+    if (parity_end == parity_start) {
+        Status = STATUS_SUCCESS;
+        goto exit;
+    }
     
-    for (i = 0; i < c->chunk_item->num_stripes - 2; i++) {
-        if (stripes[i].start == stripes[i].end) {
-            num_reads++;
-            
-            if (multiple_stripes)
-                num_reads++;
+    parity1 = (((address - c->offset) / ((c->chunk_item->num_stripes - 2) * c->chunk_item->stripe_length)) + c->chunk_item->num_stripes - 2) % c->chunk_item->num_stripes;
+    stripes[parity1].start = stripes[(parity1 + 1) % c->chunk_item->num_stripes].start = parity_start;
+    
+    parity1 = (((address - c->offset + length - 1) / ((c->chunk_item->num_stripes - 2) * c->chunk_item->stripe_length)) + c->chunk_item->num_stripes - 2) % c->chunk_item->num_stripes;
+    stripes[parity1].end = stripes[(parity1 + 1) % c->chunk_item->num_stripes].end = parity_end;
+    
+    for (i = 0; i < c->chunk_item->num_stripes; i++) {
+        if (stripes[i].start == 0 && stripes[i].end == 0) {
+            fragment_len += parity_end - parity_start;
+            num_fragments++;
         } else {
-            if (stripes[i].start > start)
-                num_reads++;
+            if (stripes[i].start > parity_start) {
+                fragment_len += stripes[i].start - parity_start;
+                num_fragments++;
+            }
             
-            if (stripes[i].end < end)
-                num_reads++;
+            if (stripes[i].end < parity_end) {
+                fragment_len += parity_end - stripes[i].end;
+                num_fragments++;
+            }
         }
     }
     
-    if (num_reads > 0) {
-        UINT32 j;
-        read_stripe_master* master;
-        read_stripe* read_stripes;
-        CHUNK_ITEM_STRIPE* cis = (CHUNK_ITEM_STRIPE*)&c->chunk_item[1];
-        NTSTATUS Status;
+    if (fragment_len > 0) {
+        fragments = ExAllocatePoolWithTag(NonPagedPool, fragment_len, ALLOC_TAG);
+        if (!fragments) {
+            ERR("out of memory\n");
+            Status = STATUS_INSUFFICIENT_RESOURCES;
+            goto exit;
+        }
+
+        fragment_mdl = IoAllocateMdl(fragments, fragment_len, FALSE, FALSE, NULL);
+        if (!fragment_mdl) {
+            ERR("out of memory\n");
+            Status = STATUS_INSUFFICIENT_RESOURCES;
+            goto exit;
+        }
         
-        master = ExAllocatePoolWithTag(NonPagedPool, sizeof(read_stripe_master), ALLOC_TAG);
-        if (!master) {
+        MmBuildMdlForNonPagedPool(fragment_mdl);
+        
+        fragment_pfns = (PFN_NUMBER*)(fragment_mdl + 1);
+        
+        context.stripes = ExAllocatePoolWithTag(NonPagedPool, sizeof(read_context_stripe) * num_fragments, ALLOC_TAG);
+        if (!context.stripes) {
             ERR("out of memory\n");
-            return STATUS_INSUFFICIENT_RESOURCES;
+            Status = STATUS_INSUFFICIENT_RESOURCES;
+            goto exit;
         }
         
-        read_stripes = ExAllocatePoolWithTag(NonPagedPool, sizeof(read_stripe) * num_reads, ALLOC_TAG);
-        if (!read_stripes) {
+        RtlZeroMemory(context.stripes, sizeof(read_context_stripe) * num_fragments);
+        
+        KeInitializeEvent(&context.Event, NotificationEvent, FALSE);
+        context.total = context.left = num_fragments;
+    }
+    
+    log_stripes = ExAllocatePoolWithTag(NonPagedPool, sizeof(log_stripe) * (c->chunk_item->num_stripes - 2), ALLOC_TAG);
+    if (!log_stripes) {
+        ERR("out of memory\n");
+        Status = STATUS_INSUFFICIENT_RESOURCES;
+        goto exit;
+    }
+    
+    RtlZeroMemory(log_stripes, sizeof(log_stripe) * (c->chunk_item->num_stripes - 2));
+    
+    for (i = 0; i < c->chunk_item->num_stripes - 2; i++) {
+        log_stripes[i].mdl = IoAllocateMdl(NULL, parity_end - parity_start, FALSE, FALSE, NULL);
+        if (!log_stripes[i].mdl) {
             ERR("out of memory\n");
-            ExFreePool(master);
-            return STATUS_INSUFFICIENT_RESOURCES;
+            Status = STATUS_INSUFFICIENT_RESOURCES;
+            goto exit;
         }
         
-        parity1 = (((address - c->offset) / ((c->chunk_item->num_stripes - 2) * c->chunk_item->stripe_length)) + c->chunk_item->num_stripes - 2) % c->chunk_item->num_stripes;
-        stripenum = (parity1 + 2) % c->chunk_item->num_stripes;
+        log_stripes[i].mdl->MdlFlags |= MDL_PARTIAL;
+        log_stripes[i].pfns = (PFN_NUMBER*)(log_stripes[i].mdl + 1);
+    }
+    
+    parity1 = (((address - c->offset) / ((c->chunk_item->num_stripes - 2) * c->chunk_item->stripe_length)) + c->chunk_item->num_stripes - 2) % c->chunk_item->num_stripes;
+    
+    if (fragment_len > 0) {
+        UINT16 stripe = (parity1 + 2) % c->chunk_item->num_stripes;
         
-        j = 0;
+        fragments2 = fragments;
+        
         for (i = 0; i < c->chunk_item->num_stripes - 2; i++) {
-            if (stripes[i].start > start || stripes[i].start == stripes[i].end) {
-                ULONG readlen;
+            if ((stripes[stripe].start == 0 && stripes[stripe].end == 0) || stripes[stripe].start > parity_start) {
+                ULONG len;
                 
-                read_stripes[j].Irp = NULL;
-                read_stripes[j].devobj = c->devices[stripenum]->devobj;
-                read_stripes[j].master = master;
-                
-                if (stripes[i].start != stripes[i].end)
-                    readlen = stripes[i].start - start;
+                if (stripes[stripe].start == 0 && stripes[stripe].end == 0)
+                    len = parity_end - parity_start;
                 else
-                    readlen = firststripesize;
+                    len = stripes[stripe].start - parity_start;
                 
-                Status = make_read_irp(Irp, &read_stripes[j], start + cis[stripenum].offset, stripes[stripenum].data, readlen);
-                
+                context.stripes[frag_num].dev = c->devices[stripe];
+                Status = async_read_phys(&context, &context.stripes[frag_num], c->devices[stripe]->devobj, cis[stripe].offset + parity_start, len, fragments2);
                 if (!NT_SUCCESS(Status)) {
-                    ERR("make_read_irp returned %08x\n", Status);
-                    j++;
-                    goto readend;
+                    ERR("async_read_phys returned %08x\n", Status);
+                    goto exit;
                 }
                 
-                stripes[stripenum].skip_start = readlen;
+                frag_num++;
                 
-                j++;
-                if (j == num_reads) break;
+                RtlCopyMemory(log_stripes[i].pfns, fragment_pfns, len * sizeof(PFN_NUMBER) >> PAGE_SHIFT);
+                log_stripes[i].pfns += len >> PAGE_SHIFT;
+                
+                fragments2 += len;
+                fragment_pfns += len >> PAGE_SHIFT;
             }
             
-            stripenum = (stripenum + 1) % c->chunk_item->num_stripes;
+            stripe = (stripe + 1) % c->chunk_item->num_stripes;
         }
+    }
+    
+    parity1 = (((address - c->offset + length - 1) / ((c->chunk_item->num_stripes - 2) * c->chunk_item->stripe_length)) + c->chunk_item->num_stripes - 2) % c->chunk_item->num_stripes;
+    
+    if (fragment_len > 0) {
+        UINT16 stripe = (parity1 + 2) % c->chunk_item->num_stripes;
         
-        if (j < num_reads) {
-            parity1 = (((address + length - 1 - c->offset) / ((c->chunk_item->num_stripes - 2) * c->chunk_item->stripe_length)) + c->chunk_item->num_stripes - 2) % c->chunk_item->num_stripes;
-            stripenum = (parity1 + 2) % c->chunk_item->num_stripes;
-            
-            for (i = 0; i < c->chunk_item->num_stripes - 2; i++) {
-                if ((stripes[i].start != stripes[i].end && stripes[i].end < end) || (stripes[i].start == stripes[i].end && multiple_stripes)) {
-                    read_stripes[j].Irp = NULL;
-                    read_stripes[j].devobj = c->devices[stripenum]->devobj;
-                    read_stripes[j].master = master;
+        for (i = 0; i < c->chunk_item->num_stripes - 2; i++) {
+            if ((stripes[stripe].start != 0 || stripes[stripe].end != 0) && stripes[stripe].end < parity_end) {
+                ULONG len = parity_end - stripes[stripe].end;
+                PFN_NUMBER* pl;
                 
-                    if (stripes[i].start == stripes[i].end) {
-                        Status = make_read_irp(Irp, &read_stripes[j], start + firststripesize + cis[stripenum].offset, &stripes[stripenum].data[firststripesize], laststripesize);
-                        stripes[stripenum].skip_end = laststripesize;
-                    } else {
-                        Status = make_read_irp(Irp, &read_stripes[j], stripes[i].end + cis[stripenum].offset, &stripes[stripenum].data[stripes[i].end - start], end - stripes[i].end);
-                        stripes[stripenum].skip_end = end - stripes[i].end;
-                    }
-                    
-                    if (!NT_SUCCESS(Status)) {
-                        ERR("make_read_irp returned %08x\n", Status);
-                        j++;
-                        goto readend;
-                    }
-                    
-                    j++;
-                    if (j == num_reads) break;
+                context.stripes[frag_num].dev = c->devices[stripe];
+                Status = async_read_phys(&context, &context.stripes[frag_num], c->devices[stripe]->devobj, cis[stripe].offset + stripes[stripe].end, len, fragments2);
+                if (!NT_SUCCESS(Status)) {
+                    ERR("async_read_phys returned %08x\n", Status);
+                    goto exit;
                 }
                 
-                stripenum = (stripenum + 1) % c->chunk_item->num_stripes;
+                frag_num++;
+                
+                pl = (PFN_NUMBER*)(log_stripes[i].mdl + 1);
+                
+                RtlCopyMemory(&pl[(parity_end - parity_start - len) >> PAGE_SHIFT], fragment_pfns, len * sizeof(PFN_NUMBER) >> PAGE_SHIFT);
+                
+                fragments2 += len;
+                fragment_pfns += len >> PAGE_SHIFT;
             }
+            
+            stripe = (stripe + 1) % c->chunk_item->num_stripes;
         }
+    }
+    
+    wtc->parity1 = ExAllocatePoolWithTag(NonPagedPool, parity_end - parity_start, ALLOC_TAG);
+    if (!wtc->parity1) {
+        ERR("out of memory\n");
+        Status = STATUS_INSUFFICIENT_RESOURCES;
+        goto exit;
+    }
+    
+    wtc->parity2 = ExAllocatePoolWithTag(NonPagedPool, parity_end - parity_start, ALLOC_TAG);
+    if (!wtc->parity2) {
+        ERR("out of memory\n");
+        Status = STATUS_INSUFFICIENT_RESOURCES;
+        goto exit;
+    }
+    
+    wtc->parity1_mdl = IoAllocateMdl(wtc->parity1, parity_end - parity_start, FALSE, FALSE, NULL);
+    if (!wtc->parity1_mdl) {
+        ERR("out of memory\n");
+        Status = STATUS_INSUFFICIENT_RESOURCES;
+        goto exit;
+    }
+    
+    MmBuildMdlForNonPagedPool(wtc->parity1_mdl);
+    
+    wtc->parity2_mdl = IoAllocateMdl(wtc->parity2, parity_end - parity_start, FALSE, FALSE, NULL);
+    if (!wtc->parity2_mdl) {
+        ERR("out of memory\n");
+        Status = STATUS_INSUFFICIENT_RESOURCES;
+        goto exit;
+    }
+    
+    MmBuildMdlForNonPagedPool(wtc->parity2_mdl);
+    
+    if (file_write)
+        master_mdl = Irp->MdlAddress;
+    else if (((ULONG_PTR)data % PAGE_SIZE) != 0) {
+        wtc->scratch = ExAllocatePoolWithTag(NonPagedPool, length, ALLOC_TAG);
+        if (!wtc->scratch) {
+            ERR("out of memory\n");
+            Status = STATUS_INSUFFICIENT_RESOURCES;
+            goto exit;
+        }
         
-        master->stripes_left = j;
-        KeInitializeEvent(&master->event, NotificationEvent, FALSE);
+        RtlCopyMemory(wtc->scratch, data, length);
         
-        for (i = 0; i < j; i++) {
-            Status = IoCallDriver(read_stripes[i].devobj, read_stripes[i].Irp);
-            if (!NT_SUCCESS(Status)) {
-                ERR("IoCallDriver returned %08x\n", Status);
-                goto readend;
-            }
+        master_mdl = IoAllocateMdl(wtc->scratch, length, FALSE, FALSE, NULL);
+        if (!master_mdl) {
+            ERR("out of memory\n");
+            Status = STATUS_INSUFFICIENT_RESOURCES;
+            goto exit;
         }
         
-        KeWaitForSingleObject(&master->event, Executive, KernelMode, FALSE, NULL);
+        MmBuildMdlForNonPagedPool(master_mdl);
         
-        for (i = 0; i < j; i++) {
-            if (!NT_SUCCESS(read_stripes[i].iosb.Status)) {
-                Status = read_stripes[i].iosb.Status;
-                goto readend;
-            }
+        wtc->mdl = master_mdl;
+    } else {
+        master_mdl = IoAllocateMdl(data, length, FALSE, FALSE, NULL);
+        if (!master_mdl) {
+            ERR("out of memory\n");
+            Status = STATUS_INSUFFICIENT_RESOURCES;
+            goto exit;
         }
         
-        Status = STATUS_SUCCESS;
-
-readend:
-        for (i = 0; i < j; i++) {
-            if (read_stripes[i].Irp) {
-                if (read_stripes[i].devobj->Flags & DO_DIRECT_IO) {
-                    MmUnlockPages(read_stripes[i].Irp->MdlAddress);
-                    IoFreeMdl(read_stripes[i].Irp->MdlAddress);
-                }
-                
-                IoFreeIrp(read_stripes[i].Irp); // FIXME - what if IoCallDriver fails and other Irps are still running?
+        MmProbeAndLockPages(master_mdl, KernelMode, IoReadAccess);
+        
+        wtc->mdl = master_mdl;
+    }
+    
+    pfns = (PFN_NUMBER*)(master_mdl + 1);
+    parity1_pfns = (PFN_NUMBER*)(wtc->parity1_mdl + 1);
+    parity2_pfns = (PFN_NUMBER*)(wtc->parity2_mdl + 1);
+    
+    for (i = 0; i < c->chunk_item->num_stripes; i++) {
+        if (stripes[i].start != stripes[i].end) {
+            stripes[i].mdl = IoAllocateMdl((UINT8*)MmGetMdlVirtualAddress(master_mdl) + irp_offset, stripes[i].end - stripes[i].start, FALSE, FALSE, NULL);
+            if (!stripes[i].mdl) {
+                ERR("IoAllocateMdl failed\n");
+                return STATUS_INSUFFICIENT_RESOURCES;
             }
         }
-        
-        ExFreePool(read_stripes);
-        ExFreePool(master);
-        
-        if (!NT_SUCCESS(Status))
-            return Status;
     }
     
+    stripeoff = ExAllocatePoolWithTag(PagedPool, sizeof(UINT64) * c->chunk_item->num_stripes, ALLOC_TAG);
+    if (!stripeoff) {
+        ERR("out of memory\n");
+        Status = STATUS_INSUFFICIENT_RESOURCES;
+        goto exit;
+    }
+    
+    RtlZeroMemory(stripeoff, sizeof(UINT64) * c->chunk_item->num_stripes);
+    
     pos = 0;
+    parity_pos = 0;
     
-    parity1 = (((address - c->offset) / ((c->chunk_item->num_stripes - 2) * c->chunk_item->stripe_length)) + c->chunk_item->num_stripes - 2) % c->chunk_item->num_stripes;
-    parity2 = (parity1 + 1) % c->chunk_item->num_stripes;
-    stripepos = 0;
-    
-    if ((address - c->offset) % (c->chunk_item->stripe_length * (c->chunk_item->num_stripes - 2)) > 0) {
-        BOOL first = TRUE;
+    while (pos < length) {
+        PFN_NUMBER* stripe_pfns;
         
-        stripenum = (parity2 + 1) % c->chunk_item->num_stripes;
+        parity1 = (((address - c->offset + pos) / ((c->chunk_item->num_stripes - 2) * c->chunk_item->stripe_length)) + c->chunk_item->num_stripes - 2) % c->chunk_item->num_stripes;
         
-        for (logstripe = 0; logstripe < c->chunk_item->num_stripes - 2; logstripe++) {
-            ULONG copylen;
+        if (pos == 0) {
+            UINT16 stripe = (parity1 + startoffstripe + 2) % c->chunk_item->num_stripes, parity2;
+            UINT32 writelen = min(length - pos, min(stripes[stripe].end - stripes[stripe].start,
+                                                    c->chunk_item->stripe_length - (stripes[stripe].start % c->chunk_item->stripe_length)));
+            UINT32 maxwritelen = writelen;
             
-            if (pos >= length)
-                break;
+            stripe_pfns = (PFN_NUMBER*)(stripes[stripe].mdl + 1);
             
-            if (stripes[logstripe].start < start + firststripesize && stripes[logstripe].start != stripes[logstripe].end) {
-                copylen = min(start + firststripesize - stripes[logstripe].start, length - pos);
+            RtlCopyMemory(stripe_pfns, pfns, writelen * sizeof(PFN_NUMBER) >> PAGE_SHIFT);
+            
+            RtlCopyMemory(log_stripes[startoffstripe].pfns, pfns, writelen * sizeof(PFN_NUMBER) >> PAGE_SHIFT);
+            log_stripes[startoffstripe].pfns += writelen >> PAGE_SHIFT;
+            
+            stripeoff[stripe] = writelen;
+            pos += writelen;
+            
+            stripe = (stripe + 1) % c->chunk_item->num_stripes;
+            i = startoffstripe + 1;
+            
+            while (stripe != parity1) {
+                stripe_pfns = (PFN_NUMBER*)(stripes[stripe].mdl + 1);
+                writelen = min(length - pos, min(stripes[stripe].end - stripes[stripe].start, c->chunk_item->stripe_length));
                 
-                if (!first && copylen < c->chunk_item->stripe_length) {
-                    same_stripe = TRUE;
+                if (writelen == 0)
                     break;
-                }
-
-                RtlCopyMemory(&stripes[stripenum].data[firststripesize - copylen], &data2[pos], copylen);
                 
-                pos += copylen;
-                first = FALSE;
+                if (writelen > maxwritelen)
+                    maxwritelen = writelen;
+                
+                RtlCopyMemory(stripe_pfns, &pfns[pos >> PAGE_SHIFT], writelen * sizeof(PFN_NUMBER) >> PAGE_SHIFT);
+                
+                RtlCopyMemory(log_stripes[i].pfns, &pfns[pos >> PAGE_SHIFT], writelen * sizeof(PFN_NUMBER) >> PAGE_SHIFT);
+                log_stripes[i].pfns += writelen >> PAGE_SHIFT;
+                
+                stripeoff[stripe] = writelen;
+                pos += writelen;
+                
+                stripe = (stripe + 1) % c->chunk_item->num_stripes;
+                i++;
             }
             
-            stripenum = (stripenum + 1) % c->chunk_item->num_stripes;
+            stripe_pfns = (PFN_NUMBER*)(stripes[parity1].mdl + 1);
+            RtlCopyMemory(stripe_pfns, parity1_pfns, maxwritelen * sizeof(PFN_NUMBER) >> PAGE_SHIFT);
+            stripeoff[parity1] = maxwritelen;
+            
+            parity2 = (parity1 + 1) % c->chunk_item->num_stripes;
+            
+            stripe_pfns = (PFN_NUMBER*)(stripes[parity2].mdl + 1);
+            RtlCopyMemory(stripe_pfns, parity2_pfns, maxwritelen * sizeof(PFN_NUMBER) >> PAGE_SHIFT);
+            stripeoff[parity2] = maxwritelen;
+            
+            parity_pos = maxwritelen;
+        } else if (length - pos >= c->chunk_item->stripe_length * (c->chunk_item->num_stripes - 2)) {
+            UINT16 stripe = (parity1 + 2) % c->chunk_item->num_stripes, parity2;
+            
+            i = 0;
+            while (stripe != parity1) {
+                stripe_pfns = (PFN_NUMBER*)(stripes[stripe].mdl + 1);
+                
+                RtlCopyMemory(&stripe_pfns[stripeoff[stripe] >> PAGE_SHIFT], &pfns[pos >> PAGE_SHIFT], c->chunk_item->stripe_length * sizeof(PFN_NUMBER) >> PAGE_SHIFT);
+                
+                RtlCopyMemory(log_stripes[i].pfns, &pfns[pos >> PAGE_SHIFT], c->chunk_item->stripe_length * sizeof(PFN_NUMBER) >> PAGE_SHIFT);
+                log_stripes[i].pfns += c->chunk_item->stripe_length >> PAGE_SHIFT;
+                
+                stripeoff[stripe] += c->chunk_item->stripe_length;
+                pos += c->chunk_item->stripe_length;
+                
+                stripe = (stripe + 1) % c->chunk_item->num_stripes;
+                i++;
+            }
+            
+            stripe_pfns = (PFN_NUMBER*)(stripes[parity1].mdl + 1);
+            RtlCopyMemory(&stripe_pfns[stripeoff[parity1] >> PAGE_SHIFT], &parity1_pfns[parity_pos >> PAGE_SHIFT], c->chunk_item->stripe_length * sizeof(PFN_NUMBER) >> PAGE_SHIFT);
+            stripeoff[parity1] += c->chunk_item->stripe_length;
+            
+            parity2 = (parity1 + 1) % c->chunk_item->num_stripes;
+            
+            stripe_pfns = (PFN_NUMBER*)(stripes[parity2].mdl + 1);
+            RtlCopyMemory(&stripe_pfns[stripeoff[parity2] >> PAGE_SHIFT], &parity2_pfns[parity_pos >> PAGE_SHIFT], c->chunk_item->stripe_length * sizeof(PFN_NUMBER) >> PAGE_SHIFT);
+            stripeoff[parity2] += c->chunk_item->stripe_length;
+            
+            parity_pos += c->chunk_item->stripe_length;
+        } else {
+            UINT16 stripe = (parity1 + 2) % c->chunk_item->num_stripes, parity2;
+            UINT32 writelen, maxwritelen = 0;
+            
+            i = 0;
+            while (pos < length) {
+                stripe_pfns = (PFN_NUMBER*)(stripes[stripe].mdl + 1);
+                writelen = min(length - pos, min(stripes[stripe].end - stripes[stripe].start, c->chunk_item->stripe_length));
+                
+                if (writelen == 0)
+                    break;
+                
+                if (writelen > maxwritelen)
+                    maxwritelen = writelen;
+                
+                RtlCopyMemory(&stripe_pfns[stripeoff[stripe] >> PAGE_SHIFT], &pfns[pos >> PAGE_SHIFT], writelen * sizeof(PFN_NUMBER) >> PAGE_SHIFT);
+                
+                RtlCopyMemory(log_stripes[i].pfns, &pfns[pos >> PAGE_SHIFT], writelen * sizeof(PFN_NUMBER) >> PAGE_SHIFT);
+                log_stripes[i].pfns += writelen >> PAGE_SHIFT;
+                
+                stripeoff[stripe] += writelen;
+                pos += writelen;
+                
+                stripe = (stripe + 1) % c->chunk_item->num_stripes;
+                i++;
+            }
+            
+            stripe_pfns = (PFN_NUMBER*)(stripes[parity1].mdl + 1);
+            RtlCopyMemory(&stripe_pfns[stripeoff[parity1] >> PAGE_SHIFT], &parity1_pfns[parity_pos >> PAGE_SHIFT], maxwritelen * sizeof(PFN_NUMBER) >> PAGE_SHIFT);
+            
+            parity2 = (parity1 + 1) % c->chunk_item->num_stripes;
+            
+            stripe_pfns = (PFN_NUMBER*)(stripes[parity2].mdl + 1);
+            RtlCopyMemory(&stripe_pfns[stripeoff[parity2] >> PAGE_SHIFT], &parity2_pfns[parity_pos >> PAGE_SHIFT], maxwritelen * sizeof(PFN_NUMBER) >> PAGE_SHIFT);
         }
+    }
+    
+    if (fragment_len > 0) {
+        KeWaitForSingleObject(&context.Event, Executive, KernelMode, FALSE, NULL);
         
-        i = parity1 == 0 ? (c->chunk_item->num_stripes - 1) : (parity1 - 1);
-        RtlCopyMemory(stripes[parity1].data, stripes[i].data, firststripesize);
-        RtlCopyMemory(stripes[parity2].data, stripes[i].data, firststripesize);
-        i = i == 0 ? (c->chunk_item->num_stripes - 1) : (i - 1);
+        for (i = 0; i < context.total; i++) {
+            if (!NT_SUCCESS(context.stripes[i].iosb.Status)) {
+                Status = context.stripes[i].iosb.Status;
+                ERR("read returned %08x\n", Status);
+                log_device_error(Vcb, context.stripes[i].dev, BTRFS_DEV_STAT_READ_ERRORS);
+                goto exit;
+            }
+        }
+    }
+
+    for (i = 0; i < c->chunk_item->num_stripes - 2; i++) {
+        UINT8* ss = MmGetSystemAddressForMdlSafe(log_stripes[c->chunk_item->num_stripes - 3 - i].mdl, NormalPagePriority);
         
-        do {
-            do_xor(stripes[parity1].data, stripes[i].data, firststripesize);
+        if (i == 0) {
+            RtlCopyMemory(wtc->parity1, ss, parity_end - parity_start);
+            RtlCopyMemory(wtc->parity2, ss, parity_end - parity_start);
+        } else {
+            do_xor(wtc->parity1, ss, parity_end - parity_start);
             
-            galois_double(stripes[parity2].data, firststripesize);
-            do_xor(stripes[parity2].data, stripes[i].data, firststripesize);
-            
-            i = i == 0 ? (c->chunk_item->num_stripes - 1) : (i - 1);
-        } while (i != parity2);
-        
-        if (!same_stripe) {
-            stripepos = firststripesize;
-            parity1 = parity2;
-            parity2 = (parity2 + 1) % c->chunk_item->num_stripes;
+            galois_double(wtc->parity2, parity_end - parity_start);
+            do_xor(wtc->parity2, ss, parity_end - parity_start);
         }
     }
     
-    while (length >= pos + c->chunk_item->stripe_length * (c->chunk_item->num_stripes - 2)) {
-        stripenum = (parity2 + 1) % c->chunk_item->num_stripes;
-        
+    Status = STATUS_SUCCESS;
+    
+exit:
+    if (log_stripes) {
         for (i = 0; i < c->chunk_item->num_stripes - 2; i++) {
-            RtlCopyMemory(&stripes[stripenum].data[stripepos], &data2[pos], c->chunk_item->stripe_length);
-            
-            pos += c->chunk_item->stripe_length;
-            stripenum = (stripenum +1) % c->chunk_item->num_stripes;
+            if (log_stripes[i].mdl)
+                IoFreeMdl(log_stripes[i].mdl);
         }
         
-        i = parity1 == 0 ? (c->chunk_item->num_stripes - 1) : (parity1 - 1);
-        RtlCopyMemory(&stripes[parity1].data[stripepos], &stripes[i].data[stripepos], c->chunk_item->stripe_length);
-        RtlCopyMemory(&stripes[parity2].data[stripepos], &stripes[i].data[stripepos], c->chunk_item->stripe_length);
-        i = i == 0 ? (c->chunk_item->num_stripes - 1) : (i - 1);
-
-        do {
-            do_xor(&stripes[parity1].data[stripepos], &stripes[i].data[stripepos], c->chunk_item->stripe_length);
-            
-            galois_double(&stripes[parity2].data[stripepos], c->chunk_item->stripe_length);
-            do_xor(&stripes[parity2].data[stripepos], &stripes[i].data[stripepos], c->chunk_item->stripe_length);
-            
-            i = i == 0 ? (c->chunk_item->num_stripes - 1) : (i - 1);
-        } while (i != parity2);
-        
-        parity1 = parity2;
-        parity2 = (parity2 + 1) % c->chunk_item->num_stripes;
-        stripepos += c->chunk_item->stripe_length;
+        ExFreePool(log_stripes);
     }
     
-    if (pos < length) {
-        if (!same_stripe) {
-            stripenum = (parity2 + 1) % c->chunk_item->num_stripes;
-            i = 0;
-        } else
-            i = logstripe;
-        
-        while (pos < length) {
-            ULONG copylen;
+    if (context.stripes) {
+        if (context.total > 0) {
+            KeWaitForSingleObject(&context.Event, Executive, KernelMode, FALSE, NULL);
             
-            copylen = min(stripes[i].end - start - stripepos, length - pos);
-
-            RtlCopyMemory(&stripes[stripenum].data[stripepos], &data2[pos], copylen);
-            
-            pos += copylen;
-            stripenum = (stripenum + 1) % c->chunk_item->num_stripes;
-            i++;
+            for (i = 0; i < context.total; i++) {
+                if (context.stripes[i].Irp && context.stripes[i].Irp->MdlAddress) {
+                    MmUnlockPages(context.stripes[i].Irp->MdlAddress);
+                    IoFreeMdl(context.stripes[i].Irp->MdlAddress);
+                }
+            }
         }
         
-        i = parity1 == 0 ? (c->chunk_item->num_stripes - 1) : (parity1 - 1);
-        RtlCopyMemory(&stripes[parity1].data[stripepos], &stripes[i].data[stripepos], laststripesize);
-        RtlCopyMemory(&stripes[parity2].data[stripepos], &stripes[i].data[stripepos], laststripesize);
-        i = i == 0 ? (c->chunk_item->num_stripes - 1) : (i - 1);
-
-        do {
-            do_xor(&stripes[parity1].data[stripepos], &stripes[i].data[stripepos], laststripesize);
-            
-            galois_double(&stripes[parity2].data[stripepos], laststripesize);
-            do_xor(&stripes[parity2].data[stripepos], &stripes[i].data[stripepos], laststripesize);
-            
-            i = i == 0 ? (c->chunk_item->num_stripes - 1) : (i - 1);
-        } while (i != parity2);
+        ExFreePool(context.stripes);
     }
     
-    for (i = 0; i < c->chunk_item->num_stripes; i++) {
-        stripes[i].start = start;
-        stripes[i].end = end;
-    }
+    if (fragment_mdl)
+        IoFreeMdl(fragment_mdl);
     
-    return STATUS_SUCCESS;
+    if (fragments)
+        ExFreePool(fragments);
+
+    if (stripeoff)
+        ExFreePool(stripeoff);
+    
+    return Status;
 }
 
-NTSTATUS STDCALL write_data(device_extension* Vcb, UINT64 address, void* data, BOOL need_free, UINT32 length, write_data_context* wtc, PIRP Irp, chunk* c) {
+NTSTATUS STDCALL write_data(device_extension* Vcb, UINT64 address, void* data, UINT32 length, write_data_context* wtc, PIRP Irp,
+                            chunk* c, BOOL file_write, UINT32 irp_offset) {
     NTSTATUS Status;
     UINT32 i;
     CHUNK_ITEM_STRIPE* cis;
     write_data_stripe* stripe;
     write_stripe* stripes = NULL;
-    BOOL need_free2;
+    UINT64 total_writing = 0;
     
     TRACE("(%p, %llx, %p, %x)\n", Vcb, address, data, length);
     
